/*
 * SuperOfferSupplierListener.java
 *
 * Created on 17 de agosto de 2004, 13:31
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.SuperOffer;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet es el encargado de reaccionar ante la petición del proveedor de
 * modificar una superoferta, es el encargado de preparar toda la información que
 * requiere <CODE>modificarsuperoferta.jsp</CODE>
 * 
 * @author andres
 */
public class SuperOfferSupplierListener extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones de los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método crea un objeto <CODE>SupperOffer</CODE> para cargar los
	 * datos de la superoferta especificada por el proveedor por medio del
	 * identificador único de la superoferta para que este objeto contenga la
	 * información base para <CODE>modificarsuperoferta.jsp</CODE>
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				String operationType = "";
	
				if( request.getParameter("operationType") != null )
				{
					operationType = request.getParameter("operationType");
				}
	
				url = "/proveedor/modificarsuperoferta.jsp";
                                SuperOffer superOffer;
                                Transaction t;
	
				if( operationType.equals("update") )
				{
                                    
                                    //ACTUALIZAR SUPEROFERTA
                                    int key = Integer.parseInt( request.getParameter( "key" ) );
                                    superOffer = new SuperOffer( key );
                                    
                                    if( session.getAttribute( "superOffer" ) != null ){
                                        superOffer = (SuperOffer)session.getAttribute( "superOffer" );
                                    }else{
                                        session.setAttribute("superOffer", superOffer);
                                    }
                                    
                                    request.setAttribute( "superOffer", superOffer );
                                	
				}else if( operationType.equals( "updateImage" ) ){
                                
                                    //CARGAR IMAGEN SUPEROFERTA
                                    
                                    int superOfferId = Integer.parseInt( ( String )request.getAttribute( "superOfferId" ) );
                                    String imageUrl = ( String ) request.getAttribute( "imageUrl" );
                                    
                                    superOffer = new SuperOffer( superOfferId );
                                    t = new Transaction();
                                    
                                    superOffer.setImageUrl( "../images/superoffer/" + imageUrl );
                                    
                                    superOffer.update( t );
                                    
                                    if( session.getAttribute( "superOffer" ) != null ){
                                        SuperOffer sp = ( SuperOffer )session.getAttribute( "superOffer" );
                                        sp.setImageUrl( "../images/superoffer/" + imageUrl );
                                        session.setAttribute("superOffer", sp );
                                    }
                                    
                                    
                                    if( !t.execute() ){
                                    
                                        //Fallo al cargar imagen
                                        message = "Fallo al cargar la imagen";
                                        
                                    }else{
                                    
                                        //Carga de imagen completa
                                        message = "Carga de imagen completa";
                                        
                                    }
                                    
                                    url = "/proveedor/actualizarsuperofertaproveedor?key="+superOfferId+"&operationType=update";
                                    
                                }else if( operationType.equals( "addProduct" ) ){
                                    
                                    
                                    //AGREGAR PRODUCTO A SUPEROFERTA
                                    int superOfferId = Integer.parseInt( request.getParameter( "superOfferId" ) );
                                    int superItem = Integer.parseInt( request.getParameter( "superItem" ) );
                                
                                    //System.out.println( "item:" + superItem );
                                    
                                    superOffer = new SuperOffer( superOfferId );
                                    t = new Transaction();
                                    
                                    superOffer.setProductId( superItem );
                                    superOffer.update( t );
                                    
                                    if( !t.execute() ){
                                        
                                        message = MessageBuilder.buildMessage( 7 );
                                        
                                    }else{
                                        
                                        superOffer = new SuperOffer( superOfferId );
                                    
                                        if( session.getAttribute( "superOffer" ) != null ){

                                            SuperOffer sp = ( SuperOffer )session.getAttribute( "superOffer" );
                                            sp.setProductId( superOffer.getProductId() );
                                            sp.setProductName( superOffer.getProductName() );

                                            session.setAttribute( "superOffer", sp );

                                        }
                                    
                                        message = MessageBuilder.buildMessage( 4 );
                                        
                                    }
                                    
                                    url = "/proveedor/actualizarsuperofertaproveedor?key="+superOfferId+"&operationType=update";
                                    
                                }//Fin addProduct
                                
	
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}